<template>
  <div class="blog">

    <div class="search-wrapper panel-heading col-sm-12">
      <input class="form-control" type="text" v-model="searchQuery" placeholder="Search" />
    </div>
    <table style="margin-left: 10%">
      <thead>
      <tr>
        <th>Id</th>
        <th>Name</th>
        <th>Code</th>
        <th>City
          <div class="search-wrapper panel-heading col-sm-12">
          <input class="form-control" type="text" v-model="searchCity" placeholder="Search City" />
          </div>
        </th>
        <th>Space available
          <div class="search-wrapper panel-heading col-sm-12">
            <input class="form-control" type="text" v-model="searchSpace" placeholder="Search Space" />
          </div>
        </th>
        <th>Type</th>
        <th>cluster
          <div class="search-wrapper panel-heading col-sm-12">
            <input class="form-control" type="text" v-model="searchCluster" placeholder="Search cluster" />
          </div>
        </th>
        <th>is_registered</th>
        <th>is_live</th>
      </tr>
      </thead>
      <tbody>
      <tr v-for="(item, index) in filteredResources" :key="item.id" @click="showDetails(item, index)">
        <td  data-column="">{{ item.id }}</td>
        <td  data-column="">{{ item.name }}</td>
        <td  data-column="">{{ item.code }}</td>
        <td  data-column="">{{ item.city }}</td>
        <td  data-column="">{{ item.space_available }}</td>
        <td  data-column="">{{ item.type }}</td>
        <td  data-column="">{{ item.cluster }}</td>
        <td  data-column="" v-if="item.is_registered">Yes</td>
        <td  data-column="" v-if="!item.is_registered">No</td>
        <td  data-column="" v-if="item.is_live">Yes</td>
        <td  data-column="" v-if="!item.is_live">No</td>

      </tr>

      </tbody>
    </table>
  </div>
</template>
<script>
import axios from 'axios';
export default{
  name:'blog',
  created() {
    this.getData();
   /* if(this.$store.state.index !== null){
      this.getData();
    }else{
      this.getData();
    }*/
  },
  mounted() {
    /*if(this.$store.state.index !== null) {
      console.log('data1', this.items);
      this.items.splice(this.$store.state.index, 1, this.$store.state.item);
      console.log('data', this.items);
    }*/
  },
  data (){
    return{
      title:'Blog',
      searchQuery: '',
      searchCity: '',
      searchSpace: '',
      searchCluster: '',
      items: null,

    }

  },
  methods:{
    showDetails(item, index){

      this.$store.commit('setItem', item);
      this.$store.commit('setIndex', index);
      console.log(this.$store.state.item);
      this.$router.push({
        path: '/warehousesDetails',
      });
    },
    getData(){
      axios.get('warehouses.json', { baseURL: window.location.origin })
          .then((response) => { this.items = response.data;
            if(this.$store.state.index !== null) {
              console.log('data1', this.items);
              this.items.splice(this.$store.state.index, 1, this.$store.state.item);
              console.log('data', this.items);
            }})
          .catch((error) => {
            throw error.response.data;
          });
    },
  },
  computed: {
    filteredResources (){
      if(this.searchQuery){
        return this.items.filter((item)=>{
          return (item.city.toLowerCase().startsWith(this.searchQuery.toLowerCase())
              || item.name.toLowerCase().startsWith(this.searchQuery.toLowerCase())
              || item.id.toString().startsWith(this.searchQuery)
          || item.code.toString().toLowerCase().startsWith(this.searchQuery.toLowerCase())
          ||  item.space_available.toString().toLowerCase().startsWith(this.searchQuery.toLowerCase())
              ||  item.type.toLowerCase().startsWith(this.searchQuery.toLowerCase())
              ||  item.cluster.toString().toLowerCase().startsWith(this.searchQuery.toLowerCase())
              ||  item.is_registered.toString().toLowerCase().startsWith(this.searchQuery.toLowerCase())
              ||  item.is_live.toString().toLowerCase().startsWith(this.searchQuery.toLowerCase()));
        })
      }else if(this.searchCity){
        return this.items.filter((item)=>{
          return (item.city.toLowerCase().startsWith(this.searchCity.toLowerCase())
             );
        })
      }else if(this.searchSpace){
        return this.items.filter((item)=>{
          return (item.space_available.toString().startsWith(this.searchSpace)
          );
        })
      }else if(this.searchCluster){
        return this.items.filter((item)=>{
          return (item.searchCluster.toString().toLowerCase().startsWith(this.searchCluster.toLowerCase())
          );
        })
      }else{
        return this.items;
      }


    }

  }
}
</script>
<style scoped>
/*table {
  width: 750px;
  border-collapse: collapse;
  margin:50px auto;
}

!* Zebra striping *!
tr:nth-of-type(odd) {
  background: #eee;
}

th {
  background: #3498db;
  color: white;
  font-weight: bold;
}

td, th {
  padding: 10px;
  border: 1px solid #ccc;
  text-align: left;
  font-size: 18px;
}

!*
Max width before this PARTICULAR table gets nasty
This query will take effect for any screen smaller than 760px
and also iPads specifically.
*!
@media
only screen and (max-width: 760px),
(min-device-width: 768px) and (max-device-width: 1024px)  {

  table {
    width: 100%;
  }

  !* Force table to not be like tables anymore *!
  table, thead, tbody, th, td, tr {
    display: block;
  }

  !* Hide table headers (but not display: none;, for accessibility) *!
  thead tr {
    position: absolute;
    top: -9999px;
    left: -9999px;
  }

  tr { border: 1px solid #ccc; }

  td {
    !* Behave  like a "row" *!
    border: none;
    border-bottom: 1px solid #eee;
    position: relative;
    padding-left: 50%;
  }

  td:before {
    !* Now like a table header *!
    position: absolute;
    !* Top/left values mimic padding *!
    top: 6px;
    left: 6px;
    width: 45%;
    padding-right: 10px;
    white-space: nowrap;
    !* Label the data *!
    content: attr(data-column);

    color: #000;
    font-weight: bold;
  }*/


body {
  padding:1.5em;
  background: #f5f5f5
}

table {
  border: 1px #a39485 solid;
  font-size: .9em;
  box-shadow: 0 2px 5px rgba(0,0,0,.25);
  width: 100%;
  border-collapse: collapse;
  border-radius: 5px;
  overflow: hidden;
}

th {
  text-align: left;
}

thead {
  font-weight: bold;
  color: #fff;
  background: linear-gradient(to bottom right, #5195A8 0%, #70EAFF 100%);
}

td, th {
  padding: 1em .5em;
  vertical-align: middle;
}

td {
  border-bottom: 1px solid rgba(0,0,0,.1);
  background: #fff;
}

a {
  color: #73685d;
}

@media all and (max-width: 768px) {

  table, thead, tbody, th, td, tr {
    display: block;
  }

  th {
    text-align: right;
  }

  table {
    position: relative;
    padding-bottom: 0;
    border: none;
    box-shadow: 0 0 10px rgba(0,0,0,.2);
  }

  thead {
    float: left;
    white-space: nowrap;
  }

  tbody {
    overflow-x: auto;
    overflow-y: hidden;
    position: relative;
    white-space: nowrap;
  }

  tr {
    display: inline-block;
    vertical-align: top;
  }

  th {
    border-bottom: 1px solid #a39485;
  }

  td {
    border-bottom: 1px solid #e5e5e5;
  }


}



</style>